Index: src/view/TimeTrackV.h
===================================================================
--- src/view/TimeTrackV.h	(revision 0)
+++ src/view/TimeTrackV.h	(working copy)
@@ -0,0 +1,11 @@
+
+class AUDACITY_DLL_API TimeTrackV :
+virtual public TrackV
+{
+public:
+   TimeTrackV(void);
+   ~TimeTrackV(void);
+
+   void DrawTimeTrack(TimeTrack *track,
+                      wxDC & dc, const wxRect & r, const ViewInfo *viewInfo);
+};
Index: src/view/TrackV.cpp
===================================================================
--- src/view/TrackV.cpp	(revision 0)
+++ src/view/TrackV.cpp	(working copy)
@@ -0,0 +1,41 @@
+#include "../Audacity.h"
+#include "../TrackArtist.h"
+
+TrackV::TrackV(void):
+BaseV()
+{
+   vrulerv = new VRulerV();
+}
+
+TrackV::~TrackV(void)
+{
+   delete vrulerv; vrulerv=0;
+}
+
+void TrackV::DrawNegativeOffsetTrackArrows(wxDC &dc, const wxRect &r)
+{
+   // Draws two black arrows on the left side of the track to
+   // indicate the user that the track has been time-shifted
+   // to the left beyond t=0.0.
+
+   dc.SetPen(*wxBLACK_PEN);
+   AColor::Line(dc,
+                r.x + 2, r.y + 6,
+                r.x + 8, r.y + 6);
+   AColor::Line(dc,
+                r.x + 2, r.y + 6,
+                r.x + 6, r.y + 2);
+   AColor::Line(dc,
+                r.x + 2, r.y + 6,
+                r.x + 6, r.y + 10);
+   AColor::Line(dc,
+                r.x + 2, r.y + r.height - 8,
+                r.x + 8, r.y + r.height - 8);
+   AColor::Line(dc,
+                r.x + 2, r.y + r.height - 8,
+                r.x + 6, r.y + r.height - 4);
+   AColor::Line(dc,
+                r.x + 2, r.y + r.height - 8,
+                r.x + 6, r.y + r.height - 12);
+}
+
Index: src/view/TrackV.h
===================================================================
--- src/view/TrackV.h	(revision 0)
+++ src/view/TrackV.h	(working copy)
@@ -0,0 +1,15 @@
+
+class AUDACITY_DLL_API TrackV:
+virtual public BaseV
+{
+public:
+   TrackV(void);
+   ~TrackV(void);
+
+   void DrawNegativeOffsetTrackArrows(wxDC & dc, const wxRect & r);
+
+   wxBrush blankBrush;
+   wxPen blankPen;
+
+   VRulerV *vrulerv;
+};
Index: src/view/VRulerV.cpp
===================================================================
--- src/view/VRulerV.cpp	(revision 0)
+++ src/view/VRulerV.cpp	(working copy)
@@ -0,0 +1,394 @@
+#include "../Audacity.h"
+#include "float_cast.h"
+#include "../TrackArtist.h"
+
+VRulerV::VRulerV(void):
+BaseV()
+{
+   ruler=new Ruler;
+}
+
+VRulerV::~VRulerV(void)
+{
+   delete ruler; ruler=0;
+}
+
+void VRulerV::UpdatePrefs()
+{
+   mRange = gPrefs->Read(wxT("/Spectrum/Range"), 80L);
+   mGain = gPrefs->Read(wxT("/Spectrum/Gain"), 20L);
+
+   mdBrange = gPrefs->Read(wxT("/GUI/EnvdBRange"), mdBrange);
+
+   mMaxFreq = gPrefs->Read(wxT("/Spectrum/MaxFreq"), -1);
+   mMinFreq = gPrefs->Read(wxT("/Spectrum/MinFreq"), -1);
+
+   mLogMaxFreq = gPrefs->Read(wxT("/SpectrumLog/MaxFreq"), -1);
+   if( mLogMaxFreq < 0 )
+      mLogMaxFreq = mMaxFreq;
+
+   mLogMinFreq = gPrefs->Read(wxT("/SpectrumLog/MinFreq"), -1);
+   if( mLogMinFreq < 0 )
+      mLogMinFreq = mMinFreq;
+
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+   mFftSkipPoints = gPrefs->Read(wxT("/Spectrum/FFTSkipPoints"), 0L);
+#endif //EXPERIMENTAL_FFT_SKIP_POINTS
+}
+
+void VRulerV::DrawVRuler(Track *t, wxDC * dc, wxRect & r)
+{
+   int kind = t->GetKind();
+
+   // Label and Time tracks do not have a vruler
+   // But give it a beveled area
+   if (kind == Track::Label || kind == Track::Time) {
+      wxRect bev = r;
+      bev.Inflate(-1, -1);
+      bev.width += 1;
+      AColor::BevelTrackInfo(*dc, true, bev);
+
+      return;
+   }
+
+   // All waves have a ruler in the info panel
+   // The ruler needs a bevelled surround.
+   if (kind == Track::Wave) {
+      wxRect bev = r;
+      bev.Inflate(-1, -1);
+      bev.width += 1;
+      AColor::BevelTrackInfo(*dc, true, bev);
+
+      // Pitch doesn't have a ruler
+      if (((WaveTrack *)t)->GetDisplay() == WaveTrack::PitchDisplay) {
+         return;
+      }
+
+      // Right align the ruler
+      wxRect rr = r;
+      rr.width--;
+      if (t->vrulerSize.GetWidth() < r.GetWidth()) {
+         int adj = rr.GetWidth() - t->vrulerSize.GetWidth();
+         rr.x += adj;
+         rr.width -= adj;
+      }
+
+      UpdateVRuler(t, rr);
+
+      ruler->Draw(*dc);
+
+      return;
+   }
+
+#ifdef USE_MIDI
+   // The note track draws a vertical keyboard to label pitches
+   if (kind == Track::Note) {
+      UpdateVRuler(t, r);
+
+      dc->SetPen(*wxTRANSPARENT_PEN);
+      dc->SetBrush(*wxWHITE_BRUSH);
+      wxRect bev = r;
+      bev.x++;
+      bev.y++;
+      bev.width--;
+      bev.height--;
+      dc->DrawRectangle(bev);
+
+      r.y += 2;
+      r.height -= 2;
+
+      //int bottom = GetBottom((NoteTrack *) t, r);
+      NoteTrack *track = (NoteTrack *) t;
+      track->PrepareIPitchToY(r);
+
+      wxPen hilitePen;
+      hilitePen.SetColour(120, 120, 120);
+      wxBrush blackKeyBrush;
+      blackKeyBrush.SetColour(70, 70, 70);
+
+      dc->SetBrush(blackKeyBrush);
+
+      int fontSize = 10;
+#ifdef __WXMSW__
+      fontSize = 8;
+#endif
+
+      wxFont labelFont(fontSize, wxSWISS, wxNORMAL, wxNORMAL);
+      dc->SetFont(labelFont);
+
+      int octave = 0;
+      int obottom = track->GetOctaveBottom(octave);
+      int marg = track->GetNoteMargin();
+      //IPITCH_TO_Y(octave * 12) + PITCH_HEIGHT + 1;
+      while (obottom >= r.y) {
+         dc->SetPen(*wxBLACK_PEN);
+         for (int white = 0; white < 7; white++) {
+            int pos = track->GetWhitePos(white);
+            if (obottom - pos > r.y + marg + 1 && 
+                // don't draw too close to margin line -- it's annoying
+                obottom - pos < r.y + r.height - marg - 3)
+               AColor::Line(*dc, r.x, obottom - pos,
+                            r.x + r.width, obottom - pos);
+         }
+         wxRect br = r;
+         br.height = track->GetPitchHeight();
+         br.x++;
+         br.width = 17;
+         for (int black = 0; black < 5; black++) {
+            br.y = obottom - track->GetBlackPos(black);
+            if (br.y > r.y + marg - 2 && br.y + br.height < r.y + r.height - marg) {
+               dc->SetPen(hilitePen);
+               dc->DrawRectangle(br);
+               dc->SetPen(*wxBLACK_PEN);
+               AColor::Line(*dc,
+                            br.x + 1, br.y + br.height - 1,
+                            br.x + br.width - 1, br.y + br.height - 1);
+               AColor::Line(*dc,
+                            br.x + br.width - 1, br.y + 1,
+                            br.x + br.width - 1, br.y + br.height - 1);
+            }
+         }
+
+         if (octave >= 1 && octave <= 10) {
+            wxString s;
+            // ISO standard: A440 is in the 4th octave, denoted
+            // A4 <- the "4" should be a subscript.
+            s.Printf(wxT("C%d"), octave - 1);
+            long width, height;
+            dc->GetTextExtent(s, &width, &height);
+            if (obottom - height + 4 > r.y &&
+                obottom + 4 < r.y + r.height) {
+               dc->SetTextForeground(wxColour(60, 60, 255));
+               dc->DrawText(s, r.x + r.width - width,
+                            obottom - height + 2);
+            }
+         }
+         obottom = track->GetOctaveBottom(++octave);
+      }
+      // draw lines delineating the out-of-bounds margins
+      dc->SetPen(*wxBLACK_PEN);
+      // you would think the -1 offset here should be -2 to match the
+      // adjustment to r.y (see above), but -1 produces correct output
+      AColor::Line(*dc, r.x, r.y + marg - 1, r.x + r.width, r.y + marg - 1);
+      // since the margin gives us the bottom of the line, 
+      // the extra -1 gets us to the top
+      AColor::Line(*dc, r.x, r.y + r.height - marg - 1,
+                        r.x + r.width, r.y + r.height - marg - 1);
+
+   }
+#endif // USE_MIDI
+
+}
+
+void VRulerV::UpdateVRuler(Track *t, wxRect & r)
+{
+   // Label tracks do not have a vruler
+   if (t->GetKind() == Track::Label) {
+      return;
+   }
+
+   // All waves have a ruler in the info panel
+   // The ruler needs a bevelled surround.
+   if (t->GetKind() == Track::Wave) {
+      WaveTrack *wt = (WaveTrack *)t;
+      int display = wt->GetDisplay();
+
+      if (display == WaveTrack::WaveformDisplay) {
+         // Waveform
+
+         float min, max;
+         wt->GetDisplayBounds(&min, &max);
+
+         ruler->SetBounds(r.x, r.y+1, r.x + r.width, r.y + r.height-1);
+         ruler->SetOrientation(wxVERTICAL);
+         ruler->SetRange(max, min);
+         ruler->SetFormat(Ruler::RealFormat);
+         ruler->SetUnits(wxT(""));
+         ruler->SetLabelEdges(false);
+         ruler->SetLog(false);
+      }
+      else if (display == WaveTrack::WaveformDBDisplay) {
+         // Waveform (db)
+
+         ruler->SetUnits(wxT(""));
+
+         float min, max;
+         wt->GetDisplayBounds(&min, &max);
+
+         if (max > 0) {
+            int top = 0;
+            float topval = 0;
+            int bot = r.height;
+            float botval = -mdBrange;
+
+            if (min < 0) {
+               bot = top + (int)((max / (max-min))*(bot-top));
+               min = 0;
+            }
+
+            if (max > 1) {
+               top += (int)((max-1)/(max-min) * (bot-top));
+               max = 1;
+            }
+
+            if (max < 1)
+               topval = -((1-max)*mdBrange);
+
+            if (min > 0) {
+               botval = -((1-min)*mdBrange);
+            }
+
+            if (topval > botval && bot > top+10) {
+               ruler->SetBounds(r.x, r.y+top+1, r.x + r.width, r.y + bot-1);
+               ruler->SetOrientation(wxVERTICAL);
+               ruler->SetRange(topval, botval);
+               ruler->SetFormat(Ruler::LinearDBFormat);
+               ruler->SetLabelEdges(true);
+               ruler->SetLog(false);
+            }
+         }
+      }
+      else if (display == WaveTrack::SpectrumDisplay) {
+         // Spectrum
+
+         if (r.height < 60)
+            return;
+
+         double rate = wt->GetRate();
+         int freq = lrint(rate/2.);
+
+         int maxFreq = GetSpectrumMaxFreq(freq);
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+         maxFreq/=(mFftSkipPoints+1);
+#endif //EXPERIMENTAL_FFT_SKIP_POINTS
+         if(maxFreq > freq)
+            maxFreq = freq;
+
+         int minFreq = GetSpectrumMinFreq(0);
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+         minFreq/=(mFftSkipPoints+1);
+#endif //EXPERIMENTAL_FFT_SKIP_POINTS
+         if(minFreq < 0)
+            minFreq = 0;
+
+         /*
+            draw the ruler
+            we will use Hz if maxFreq is < 2000, otherwise we represent kHz,
+            and append to the numbers a "k"
+         */
+         ruler->SetBounds(r.x, r.y+1, r.x + r.width, r.y + r.height-1);
+         ruler->SetOrientation(wxVERTICAL);
+         ruler->SetFormat(Ruler::RealFormat);
+         ruler->SetLabelEdges(true);
+         // use kHz in scale, if appropriate
+         if (maxFreq>=2000) {
+            ruler->SetRange((maxFreq/1000.), (minFreq/1000.));
+            ruler->SetUnits(wxT("k"));
+         } else {
+            // use Hz
+            ruler->SetRange(int(maxFreq), int(minFreq));
+            ruler->SetUnits(wxT(""));
+         }
+         ruler->SetLog(false);
+      }
+      else if (display == WaveTrack::SpectrumLogDisplay) {
+         // SpectrumLog
+
+         if (r.height < 10)
+            return;
+
+         double rate = wt->GetRate();
+         int freq = lrint(rate/2.);
+
+         int maxFreq = GetSpectrumLogMaxFreq(freq);
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+         maxFreq/=(mFftSkipPoints+1);
+#endif //EXPERIMENTAL_FFT_SKIP_POINTS
+         if(maxFreq > freq)
+            maxFreq = freq;
+
+         int minFreq = GetSpectrumLogMinFreq(freq/1000.0);
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+         minFreq/=(mFftSkipPoints+1);
+#endif //EXPERIMENTAL_FFT_SKIP_POINTS
+         if(minFreq < 1)
+            minFreq = 1;
+
+         /*
+            draw the ruler
+            we will use Hz if maxFreq is < 2000, otherwise we represent kHz,
+            and append to the numbers a "k"
+         */
+         ruler->SetBounds(r.x, r.y+1, r.x + r.width, r.y + r.height-1);
+         ruler->SetOrientation(wxVERTICAL);
+         ruler->SetFormat(Ruler::IntFormat);
+         ruler->SetLabelEdges(true);
+         ruler->SetRange(maxFreq, minFreq);
+         ruler->SetUnits(wxT(""));
+         ruler->SetLog(true);
+      }
+      else if (display == WaveTrack::PitchDisplay) {
+         // Pitch
+      }
+   }
+
+#ifdef USE_MIDI
+   // The note track isn't drawing a ruler at all!
+   // But it needs to!
+   else if (t->GetKind() == Track::Note) {
+      ruler->SetBounds(r.x, r.y+1, r.x + 1, r.y + r.height-1);
+      ruler->SetOrientation(wxVERTICAL);
+   }
+#endif // USE_MIDI
+
+   ruler->GetMaxSize(&t->vrulerSize.x, &t->vrulerSize.y);
+}
+
+int VRulerV::GetSpectrumMinFreq(int deffreq)
+{
+   return mMinFreq < 0 ? deffreq : mMinFreq;
+}
+
+int VRulerV::GetSpectrumMaxFreq(int deffreq)
+{
+   return mMaxFreq < 0 ? deffreq : mMaxFreq;
+}
+
+int VRulerV::GetSpectrumLogMinFreq(int deffreq)
+{
+   return mLogMinFreq < 0 ? deffreq : mLogMinFreq;
+}
+
+int VRulerV::GetSpectrumLogMaxFreq(int deffreq)
+{
+   return mLogMaxFreq < 0 ? deffreq : mLogMaxFreq;
+}
+
+// Set various preference values
+void VRulerV::SetSpectrumMinFreq(int freq)
+{
+   mMinFreq = freq;
+}
+
+void VRulerV::SetSpectrumMaxFreq(int freq)
+{
+   mMaxFreq = freq;
+}
+
+void VRulerV::SetSpectrumLogMinFreq(int freq)
+{
+   mLogMinFreq = freq;
+}
+
+void VRulerV::SetSpectrumLogMaxFreq(int freq)
+{
+   mLogMaxFreq = freq;
+}
+
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+int VRulerV::GetSpectrumFftSkipPoints()
+{
+   return mFftSkipPoints;
+}
+#endif
+
Index: src/view/VRulerV.h
===================================================================
--- src/view/VRulerV.h	(revision 0)
+++ src/view/VRulerV.h	(working copy)
@@ -0,0 +1,43 @@
+
+class AUDACITY_DLL_API VRulerV:
+virtual public BaseV
+{
+public:
+   VRulerV(void);
+   ~VRulerV(void);
+
+   void UpdatePrefs();
+
+   void DrawVRuler(Track *t, wxDC *dc, wxRect & r);
+   void UpdateVRuler(Track *t, wxRect & r);
+
+   int GetSpectrumMinFreq(int deffreq);
+   int GetSpectrumMaxFreq(int deffreq);
+   int GetSpectrumLogMinFreq(int deffreq);
+   int GetSpectrumLogMaxFreq(int deffreq);
+
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+   int GetSpectrumFftSkipPoints();
+#endif
+
+   void SetSpectrumMinFreq(int freq);
+   void SetSpectrumMaxFreq(int freq);
+   void SetSpectrumLogMinFreq(int freq);
+   void SetSpectrumLogMaxFreq(int freq);
+
+   Ruler *ruler;
+
+   float mdBrange;            // "/GUI/EnvdBRange"
+
+   int mLogMaxFreq;           // "/SpectrumLog/MaxFreq"
+   int mLogMinFreq;           // "/SpectrumLog/MinFreq"
+   int mMaxFreq;              // "/Spectrum/MaxFreq"
+   int mMinFreq;              // "/Spectrum/MinFreq"
+
+   int mRange;                // "/Spectrum/Range"
+   int mGain;                 // "/Spectrum/Gain"
+
+#ifdef EXPERIMENTAL_FFT_SKIP_POINTS
+   int mFftSkipPoints;        // "/Spectrum/FFTSkipPoints"
+#endif //EXPERIMENTAL_FFT_SKIP_POINTS
+};
